#ifndef GRID_INC
#define GRID_INC

#include <vector>
#include <fstream>

using namespace std;
using Vec = vector<double>;
using Mat = vector<Vec>;

class Grid{
	int nx, ny; 			// Number of vertices in x and y direction
	Mat X, Y;				// X and Y vertex coordinates
	
public:
	Grid(char* file);		// Read grid from file
	
	int Nx(){return nx;}
	int Ny(){return ny;}
	
	const Vec operator()(int i, int j){
		Vec ret(2);
		ret[0] = X[i][j];
		ret[1] = Y[i][j];
		return ret;
	} 	//Loop grid in a reasonable way
};


// We give the implementation here since it is so short....
Grid::Grid(char* filename)
{
	ifstream file(filename);
	double tmp;
	file >> tmp;
	file >> nx;
	file >> ny;
	
	double x;
	Vec row(nx);
	for(int i=0;i<ny;i++)
	{
		for(int j=0;j<nx;j++)
			file >> row[j];
		
		X.push_back(row);
	}
	for(int i=0;i<ny;i++)
	{
		for(int j=0;j<nx;j++)
			file >> row[j];
		
		Y.push_back(row);
	}

	file.close();
}
#endif