#ifndef PLOT_INC
#define PLOT_INC
#include <fstream>
#include <iostream>
#include <vector>
#include "Grid.h"
#include "bitmap_image.h"


void plot_grid(Grid& G, char* file)
{
	bitmap_image image(1024, 1024);
	image_drawer draw(image);
	draw.pen_width(1);
	draw.pen_color(255, 0, 0);
	
	
	int n = G.Nx();
	int m = G.Ny();
	std::vector<double> X0(2);
	std::vector<double> X1(2);
	std::vector<double> X2(2);
	std::vector<double> X3(2);
	int x, y;
	
	for(int i=0;i<m-1;i++)
		for(int j=0;j<n-1;j++)
	{
		X0 = G(i,j);
		X1 = G(i+1,j);
		X2 = G(i,j+1);
		X3 = G(i+1,j+1);


		draw.line_segment((int) X0[0]+512, 512-(int) X0[1], (int) X1[0]+512, 512-(int) X1[1]);
		draw.line_segment((int) X0[0]+512, 512-(int) X0[1], (int) X2[0]+512, 512-(int) X2[1]);
		draw.line_segment((int) X3[0]+512, 512-(int) X3[1], (int) X1[0]+512, 512-(int) X1[1]);
		draw.line_segment((int) X3[0]+512, 512-(int) X3[1], (int) X2[0]+512, 512-(int) X2[1]);
	}
	std::cout << "Saving image" << std::endl;
	
	image.save_image(file);
}
#endif